package net.micode.notes.gtask.remote;

import android.accounts.Account;
import android.accounts.AccountManager;
import android.accounts.AccountManagerFuture;
import android.app.Activity;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.gtask.data.Node;
import net.micode.notes.gtask.data.Task;
import net.micode.notes.gtask.data.TaskList;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.gtask.exception.NetworkFailureException;
import net.micode.notes.tool.GTaskStringUtils;
import net.micode.notes.ui.NotesPreferenceActivity;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.List;
import java.util.zip.GZIPInputStream;
import java.util.zip.Inflater;
import java.util.zip.InflaterInputStream;

// GTaskClient类用于与Google Tasks进行交互，实现诸如登录、任务和任务列表的创建、更新、移动、删除以及获取相关数据等功能
public class GTaskClient {
    private static final String TAG = GTaskClient.class.getSimpleName();

    // Google Tasks的基础URL
    private static final String GTASK_URL = "https://mail.google.com/tasks/";
    // 用于获取Google Tasks数据的URL
    private static final String GTASK_GET_URL = "https://mail.google.com/tasks/ig";
    // 用于向Google Tasks发送POST请求的URL
    private static final String GTASK_POST_URL = "https://mail.google.com/tasks/r/ig";

    private static GTaskClient mInstance = null;

    // 用于发送HTTP请求的HttpClient对象
    private DefaultHttpClient mHttpClient;
    // 获取数据的具体URL
    private String mGetUrl;
    // 发送POST请求的具体URL
    private String mPostUrl;
    // 客户端版本号
    private long mClientVersion;
    // 标记是否已登录
    private boolean mLoggedin;
    // 上次登录的时间戳
    private long mLastLoginTime;
    // 用于标识操作的ID，每次操作自增
    private int mActionId;
    // 当前使用的账户
    private Account mAccount;
    // 用于暂存更新操作相关数据的JSON数组
    private JSONArray mUpdateArray;

    // 私有构造函数，初始化相关成员变量
    private GTaskClient() {
        mHttpClient = null;
        mGetUrl = GTASK_GET_URL;
        mPostUrl = GTASK_POST_URL;
        mClientVersion = -1;
        mLoggedin = false;
        mLastLoginTime = 0;
        mActionId = 1;
        mAccount = null;
        mUpdateArray = null;
    }

    // 获取GTaskClient的单例实例
    public static synchronized GTaskClient getInstance() {
        if (mInstance == null) {
            mInstance = new GTaskClient();
        }
        return mInstance;
    }

    // 执行登录操作
    public boolean login(Activity activity) {
        // 假设Cookie在5分钟后过期，若距离上次登录时间超过5分钟，则需要重新登录
        final long interval = 1000 * 60 * 5;
        if (mLastLoginTime + interval < System.currentTimeMillis()) {
            mLoggedin = false;
        }

        // 如果已登录，但当前账户与设置中的同步账户不一致，也需要重新登录
        if (mLoggedin
                && !TextUtils.equals(getSyncAccount().name, NotesPreferenceActivity
                        .getSyncAccountName(activity))) {
            mLoggedin = false;
        }

        if (mLoggedin) {
            Log.d(TAG, "already logged in");
            return true;
        }

        mLastLoginTime = System.currentTimeMillis();
        // 登录Google账户获取授权令牌
        String authToken = loginGoogleAccount(activity, false);
        if (authToken == null) {
            Log.e(TAG, "login google account failed");
            return false;
        }

        // 如果账户不是以gmail.com或googlemail.com结尾（可能是自定义域名），则使用自定义域名相关的URL进行登录
        if (!(mAccount.name.toLowerCase().endsWith("gmail.com") || mAccount.name.toLowerCase()
                .endsWith("googlemail.com"))) {
            StringBuilder url = new StringBuilder(GTASK_URL).append("a/");
            int index = mAccount.name.indexOf('@') + 1;
            String suffix = mAccount.name.substring(index);
            url.append(suffix + "/");
            mGetUrl = url.toString() + "ig";
            mPostUrl = url.toString() + "r/ig";

            if (tryToLoginGtask(activity, authToken)) {
                mLoggedin = true;
            }
        }

        // 如果使用自定义域名登录失败，则尝试使用Google官方URL登录
        if (!mLoggedin) {
            mGetUrl = GTASK_GET_URL;
            mPostUrl = GTASK_POST_URL;
            if (!tryToLoginGtask(activity, authToken)) {
                return false;
            }
        }

        mLoggedin = true;
        return true;
    }

    // 登录Google账户获取授权令牌
    private String loginGoogleAccount(Activity activity, boolean invalidateToken) {
        String authToken;
        // 获取账户管理器
        AccountManager accountManager = AccountManager.get(activity);
        // 获取所有Google类型的账户
        Account[] accounts = accountManager.getAccountsByType("com.google");

        if (accounts.length == 0) {
            Log.e(TAG, "there is no available google account");
            return null;
        }

        // 获取设置中的同步账户名称
        String accountName = NotesPreferenceActivity.getSyncAccountName(activity);
        Account account = null;
        for (Account a : accounts) {
            if (a.name.equals(accountName)) {
                account = a;
                break;
            }
        }
        if (account != null) {
            mAccount = account;
        } else {
            Log.e(TAG, "unable to get an account with the same name in the settings");
            return null;
        }

        // 获取授权令牌
        AccountManagerFuture<Bundle> accountManagerFuture = accountManager.getAuthToken(account,
                "goanna_mobile", null, activity, null, null);
        try {
            Bundle authTokenBundle = accountManagerFuture.getResult();
            authToken = authTokenBundle.getString(AccountManager.KEY_AUTHTOKEN);
            if (invalidateToken) {
                // 如果需要使令牌失效，则先失效再重新获取
                accountManager.invalidateAuthToken("com.google", authToken);
                loginGoogleAccount(activity, false);
            }
        } catch (Exception e) {
            Log.e(TAG, "get auth token failed");
            authToken = null;
        }

        return authToken;
    }

    // 尝试登录Google Tasks
    private boolean tryToLoginGtask(Activity activity, String authToken) {
        if (!loginGtask(authToken)) {
            // 如果登录失败，可能是授权令牌过期，先使令牌失效再重新尝试登录Google账户获取新令牌，然后再次登录Google Tasks
            authToken = loginGoogleAccount(activity, true);
            if (authToken == null) {
                Log.e(TAG, "login google account failed");
                return false;
            }

            if (!loginGtask(authToken)) {
                Log.e(TAG, "login gtask failed");
                return false;
            }
        }
        return true;
    }

    // 实际执行登录Google Tasks的操作，获取相关信息（如客户端版本号等）
    private boolean loginGtask(String authToken) {
        int timeoutConnection = 10000;
        int timeoutSocket = 15000;
        // 设置HTTP请求的参数，包括连接超时和读取超时时间
        HttpParams httpParameters = new BasicHttpParams();
        HttpConnectionParams.setConnectionTimeout(httpParameters, timeoutConnection);
        HttpConnectionParams.setSoTimeout(httpParameters, timeoutSocket);
        mHttpClient = new DefaultHttpClient(httpParameters);
        BasicCookieStore localBasicCookieStore = new BasicCookieStore();
        mHttpClient.setCookieStore(localBasicCookieStore);
        HttpProtocolParams.setUseExpectContinue(mHttpClient.getParams(), false);

        // 登录Google Tasks，发送带有授权令牌的GET请求
        try {
            String loginUrl = mGetUrl + "?auth=" + authToken;
            HttpGet httpGet = new HttpGet(loginUrl);
            HttpResponse response = null;
            response = mHttpClient.execute(httpGet);

            // 获取登录后的Cookie信息，检查是否包含认证相关的Cookie（名称包含"GTL"）
            List<Cookie> cookies = mHttpClient.getCookieStore().getCookies();
            boolean hasAuthCookie = false;
            for (Cookie cookie : cookies) {
                if (cookie.getName().contains("GTL")) {
                    hasAuthCookie = true;
                }
            }
            if (!hasAuthCookie) {
                Log.w(TAG, "it seems that there is no auth cookie");
            }

            // 从响应中获取客户端版本号等信息，通过解析返回的JavaScript代码中的相关数据
            String resString = getResponseContent(response.getEntity());
            String jsBegin = "_setup(";
            String jsEnd = ")}</script>";
            int begin = resString.indexOf(jsBegin);
            int end = resString.lastIndexOf(jsEnd);
            String jsString = null;
            if (begin != -1 && end != -1 && begin < end) {
                jsString = resString.substring(begin + jsBegin.length(), end);
            }
            JSONObject js = new JSONObject(jsString);
            mClientVersion = js.getLong("v");
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return false;
        } catch (Exception e) {
            // 捕获其他所有异常，若发生异常则登录失败
            Log.e(TAG, "httpget gtask_url failed");
            return false;
        }

        return true;
    }

    // 获取下一个操作的ID
    private int getActionId() {
        return mActionId++;
    }

    // 创建用于发送POST请求的HttpPost对象，并设置相关请求头
    private HttpPost createHttpPost() {
        HttpPost httpPost = new HttpPost(mPostUrl);
        httpPost.setHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
        httpPost.setHeader("AT", "1");
        return httpPost;
    }

    // 从HTTP实体中获取响应内容，根据内容编码（如gzip、deflate等）进行相应的解压处理
    private String getResponseContent(HttpEntity entity) throws IOException {
        String contentEncoding = null;
        if (entity.getContentEncoding() != null) {
            contentEncoding = entity.getContentEncoding().getValue();
            Log.d(TAG, "encoding: " + contentEncoding);
        }

        InputStream input = entity.getContent();
        if (contentEncoding != null && contentEncoding.equalsIgnoreCase("gzip")) {
            input = new GZIPInputStream(entity.getContent());
        } else if (contentEncoding != null && contentEncoding.equalsIgnoreCase("deflate")) {
            Inflater inflater = new Inflater(true);
            input = new InflaterInputStream(entity.getContent(), inflater);
        }

        try {
            InputStreamReader isr = new InputStreamReader(input);
            BufferedReader br = new BufferedReader(isr);
            StringBuilder sb = new StringBuilder();

            while (true) {
                String buff = br.readLine();
                if (buff == null) {
                    return sb.toString();
                }
                sb = sb.append(buff);
            }
        } finally {
            input.close();
        }
    }

    // 发送POST请求，将JSON数据发送到Google Tasks服务器，并处理响应返回的JSON数据
    private JSONObject postRequest(JSONObject js) throws NetworkFailureException {
        if (!mLoggedin) {
            Log.e(TAG, "please login first");
            throw new ActionFailureException("not logged in");
        }

        HttpPost httpPost = createHttpPost();
        try {
            LinkedList<BasicNameValuePair> list = new LinkedList<BasicNameValuePair>();
            list.add(new BasicNameValuePair("r", js.toString()));
            UrlEncodedFormEntity entity = new UrlEncodedFormEntity(list, "UTF-8");
            httpPost.setEntity(entity);

            // 执行POST请求并获取响应，然后解析响应内容为JSONObject返回
            HttpResponse response = mHttpClient.execute(httpPost);
            String jsString = getResponseContent(response.getEntity());
            return new JSONObject(jsString);

        } catch (ClientProtocolException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new NetworkFailureException("postRequest failed");
        } catch (IOException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new NetworkFailureException("postRequest failed");
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("unable to convert response content to jsonobject");
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("error occurs when posting request");
        }
    }

    // 创建一个任务并发送到Google Tasks服务器
    public void createTask(Task task) throws NetworkFailureException {
        commitUpdate();
        try {
            JSONObject jsPost = new JSONObject();
            JSONArray actionList = new JSONArray();

            // 将任务的创建操作添加到操作列表中
            actionList.put(task.getCreateAction(getActionId()));
            jsPost.put(GTaskStringUtils.GTASK_JSON_ACTION_LIST, actionList);

            // 设置客户端版本号
            jsPost.put(GTaskStringUtils.GTASK_JSON_CLIENT_VERSION, mClientVersion);

            // 发送POST请求并处理响应，获取新创建任务的ID并设置到任务对象中
            JSONObject jsResponse = postRequest(jsPost);
            JSONObject jsResult = (JSONObject) jsResponse.getJSONArray(
                    GTaskStringUtils.GTASK_JSON_RESULTS).get(0);
            task.setGid(jsResult.getString(GTaskStringUtils.GTASK_JSON_NEW_ID));

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("create task: handing jsonobject failed");
        }
    }

    // 创建一个任务列表并发送到Google Tasks服务器
    public void createTaskList(TaskList tasklist) throws NetworkFailureException {
        commitUpdate();
        try {
            JSONObject jsPost = new JSONObject();
            JSONArray actionList = new JSONArray();

            // 将任务列表的创建操作添加到操作列表中
            actionList.put(tasklist.getCreateAction(getActionId()));
            jsPost.put(GTaskStringUtils.GTASK_JSON_ACTION_LIST, actionList);

            // 设置客户端版本号
            jsPost.put(GTaskStringUtils.GTASK_JSON_CLIENT_VERSION, mClientVersion);

            // 发送POST请求并处理响应，获取新创建任务列表的ID并设置到任务列表对象中
            JSONObject jsResponse = postRequest(jsPost);
            JSONObject jsResult = (JSONObject) jsResponse.getJSONArray(
                    GTaskStringUtils.GTASK_JSON_RESULTS).get(0);
            tasklist.setGid(jsResult.getString(GTaskStringUtils.GTASK_JSON_NEW_ID));

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("create tasklist: handing jsonobject failed");
        }
    }

    // 提交更新操作，将暂存的更新操作数组发送到服务器
    public void commitUpdate() throws NetworkFailureException {
        if (mUpdateArray != null) {
            try {
                JSONObject jsPost = new JSONObject();

                // 设置操作列表
                jsPost.put(GTaskStringUtils.GTASK_JSON_ACTION_LIST, mUpdateArray);

                // 设置客户端版本号
                jsPost.put(GTaskStringUtils.GTASK_JSON_CLIENT_VERSION, mClientVersion);

                postRequest(jsPost);
                mUpdateArray = null;
            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("commit update: handing jsonobject failed");
            }
        }
    }

    // 添加一个节点的更新操作到暂存的更新操作数组中，限制最多10个更新项
    // 将节点的更新操作添加到更新数组中，如果更新数组中的元素超过10个，则先提交更新
    public void addUpdateNode(Node node) throws NetworkFailureException {
        if (node != null) {
            // 过多的更新项可能会导致错误，所以设置最大更新项数量为10个
            if (mUpdateArray != null && mUpdateArray.length() > 10) {
                commitUpdate();
            }

            // 如果更新数组为空，则创建一个新的JSONArray对象用于存放更新操作
            if (mUpdateArray == null)
                mUpdateArray = new JSONArray();
            // 将节点的更新操作（通过节点获取，操作ID使用当前的操作ID）添加到更新数组中
            mUpdateArray.put(node.getUpdateAction(getActionId()));
        }
    }

    // 移动任务，将任务从一个任务列表移动到另一个任务列表（可能是同一个列表内移动位置）
    public void moveTask(Task task, TaskList preParent, TaskList curParent)
            throws NetworkFailureException {
        commitUpdate();
        try {
            JSONObject jsPost = new JSONObject();
            JSONArray actionList = new JSONArray();
            JSONObject action = new JSONObject();

            // 操作列表相关设置
            // 设置操作类型为移动任务（对应预定义的移动操作类型常量）
            action.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_MOVE);
            // 设置操作的唯一ID，通过获取下一个可用的操作ID来赋值
            action.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, getActionId());
            // 设置要移动的任务的全局唯一ID
            action.put(GTaskStringUtils.GTASK_JSON_ID, task.getGid());
            // 如果移动前后的父任务列表相同（即在同一个任务列表内移动），并且任务不是该列表中的第一个任务，
            // 则设置其前一个兄弟任务的ID，用于确定移动后的顺序
            if (preParent == curParent && task.getPriorSibling() != null) {
                action.put(GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID, task.getPriorSibling());
            }
            // 设置任务原来所在的任务列表的全局唯一ID（源列表）
            action.put(GTaskStringUtils.GTASK_JSON_SOURCE_LIST, preParent.getGid());
            // 设置任务要移动到的目标任务列表的父级任务列表的全局唯一ID（目标父列表）
            action.put(GTaskStringUtils.GTASK_JSON_DEST_PARENT, curParent.getGid());
            // 如果移动是在不同的任务列表之间进行，则设置目标任务列表的全局唯一ID（目标列表）
            if (preParent != curParent) {
                action.put(GTaskStringUtils.GTASK_JSON_DEST_LIST, curParent.getGid());
            }
            // 将这个移动操作添加到操作列表中
            actionList.put(action);
            // 将操作列表添加到要发送的JSON数据对象中，对应预定义的操作列表的JSON键
            jsPost.put(GTaskStringUtils.GTASK_JSON_ACTION_LIST, actionList);

            // 设置客户端版本号，对应预定义的客户端版本号的JSON键
            jsPost.put(GTaskStringUtils.GTASK_JSON_CLIENT_VERSION, mClientVersion);

            // 发送POST请求，将包含移动任务操作信息的JSON数据发送到服务器进行处理
            postRequest(jsPost);

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            // 如果JSON处理出现异常，抛出操作失败异常，并说明是移动任务时处理JSON对象失败
            throw new ActionFailureException("move task: handing jsonobject failed");
        }
    }

    // 删除节点（比如任务、任务列表等），通过设置节点的删除标记为true，并将其更新操作发送到服务器来实现删除
    public void deleteNode(Node node) throws NetworkFailureException {
        commitUpdate();
        try {
            JSONObject jsPost = new JSONObject();
            JSONArray actionList = new JSONArray();

            // 操作列表相关设置
            // 将节点标记为已删除
            node.setDeleted(true);
            // 将节点的更新操作（此时因为已标记为删除，对应的就是删除操作）添加到操作列表中
            actionList.put(node.getUpdateAction(getActionId()));
            // 将操作列表添加到要发送的JSON数据对象中，对应预定义的操作列表的JSON键
            jsPost.put(GTaskStringUtils.GTASK_JSON_ACTION_LIST, actionList);

            // 设置客户端版本号，对应预定义的客户端版本号的JSON键
            jsPost.put(GTaskStringUtils.GTASK_JSON_CLIENT_VERSION, mClientVersion);

            // 发送POST请求，将包含删除节点操作信息的JSON数据发送到服务器进行处理
            postRequest(jsPost);
            // 发送成功后，将更新数组置空，因为相关更新操作已提交完成
            mUpdateArray = null;
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            // 如果JSON处理出现异常，抛出操作失败异常，并说明是删除节点时处理JSON对象失败
            throw new ActionFailureException("delete node: handing jsonobject failed");
        }
    }

    // 获取所有的任务列表信息，前提是已经登录成功，否则会抛出异常提示需要先登录
    public JSONArray getTaskLists() throws NetworkFailureException {
        if (!mLoggedin) {
            Log.e(TAG, "please login first");
            throw new ActionFailureException("not logged in");
        }

        try {
            // 创建一个HTTP GET请求对象，用于获取任务列表数据，请求的URL是之前设置好的获取数据的URL
            HttpGet httpGet = new HttpGet(mGetUrl);
            HttpResponse response = null;
            // 执行HTTP GET请求，获取服务器的响应
            response = mHttpClient.execute(httpGet);

            // 从响应的实体中获取内容，并进行处理，提取出包含任务列表信息的JSON数据部分
            String resString = getResponseContent(response.getEntity());
            String jsBegin = "_setup(";
            String jsEnd = ")}</script>";
            int begin = resString.indexOf(jsBegin);
            int end = resString.lastIndexOf(jsEnd);
            String jsString = null;
            if (begin != -1 && end != -1 && begin < end) {
                jsString = resString.substring(begin + jsBegin.length(), end);
            }
            JSONObject js = new JSONObject(jsString);
            // 从解析后的JSON对象中获取任务列表数组并返回，对应预定义的任务列表的JSON键
            return js.getJSONObject("t").getJSONArray(GTaskStringUtils.GTASK_JSON_LISTS);
        } catch (ClientProtocolException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            // 如果HTTP协议相关操作出现异常，抛出网络失败异常，并说明是获取任务列表时HTTP GET请求失败
            throw new NetworkFailureException("gettasklists: httpget failed");
        } catch (IOException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            // 如果输入输出操作出现异常，抛出网络失败异常，并说明是获取任务列表时HTTP GET请求失败
            throw new NetworkFailureException("gettasklists: httpget failed");
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            // 如果JSON处理出现异常，抛出操作失败异常，并说明是获取任务列表时处理JSON对象失败
            throw new ActionFailureException("get task lists: handing jasonobject failed");
        }
    }

    // 根据给定的任务列表全局唯一ID，获取该任务列表中的任务信息，需要先提交之前暂存的更新操作
    public JSONArray getTaskList(String listGid) throws NetworkFailureException {
        commitUpdate();
        try {
            JSONObject jsPost = new JSONObject();
            JSONArray actionList = new JSONArray();
            JSONObject action = new JSONObject();

            // 操作列表相关设置
            // 设置操作类型为获取所有任务（对应预定义的获取所有任务操作类型常量）
            action.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_GETALL);
            // 设置操作的唯一ID，通过获取下一个可用的操作ID来赋值
            action.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, getActionId());
            // 设置要获取任务的任务列表的全局唯一ID
            action.put(GTaskStringUtils.GTASK_JSON_LIST_ID, listGid);
            // 设置是否获取已删除的任务，这里设置为false，表示不获取已删除任务
            action.put(GTaskStringUtils.GTASK_JSON_GET_DELETED, false);
            // 将这个获取任务操作添加到操作列表中
            actionList.put(action);
            // 将操作列表添加到要发送的JSON数据对象中，对应预定义的操作列表的JSON键
            jsPost.put(GTaskStringUtils.GTASK_JSON_ACTION_LIST, actionList);

            // 设置客户端版本号，对应预定义的客户端版本号的JSON键
            jsPost.put(GTaskStringUtils.GTASK_JSON_CLIENT_VERSION, mClientVersion);

            // 发送POST请求，将包含获取任务列表中任务操作信息的JSON数据发送到服务器进行处理
            JSONObject jsResponse = postRequest(jsPost);
            // 从服务器响应的JSON数据中获取任务数组并返回，对应预定义的任务的JSON键
            return jsResponse.getJSONArray(GTaskStringUtils.GTASK_JSON_TASKS);
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            // 如果JSON处理出现异常，抛出操作失败异常，并说明是获取任务列表时处理JSON对象失败
            throw new ActionFailureException("get task list: handing jsonobject failed");
        }
    }

    // 获取当前用于同步的账户信息
    public Account getSyncAccount() {
        return mAccount;
    }

    // 重置更新数组，即将其置为空，一般用于清除之前暂存的更新操作相关数据
public void resetUpdateArray() {
    mUpdateArray = null;
}